Include "lib.bb"

;Variablen zum Scrollen mit der Maus
Global mausscroll_x
Global mausscroll_y

;Variablen fr die Spielerposition
Global set_player=False

;Fr Rasterlinien anzeigen
Global raster=False

Global ausgew_tile=0 ;Diese Zahl wird in den Map-Array gespeichert
Global maus_tilex,maus_tiley ;Maus-Koordinaten in Tiles, wird in der Hauptschleife zugewiesen

;Map mit den Wunschwerten initialisieren 
Reset()

;Hauptschleife
Repeat
	
	UserInput()
	
	DrawGame()
	
	If KeyHit(49) Then ;Wenn "N" gedrckt wird
		Reset()
	EndIf
	
	WaitTimer timer
	Flip 0 : Cls
Until KeyHit(1)
End

Function UserInput()
	;Mauskoordinaten ermitteln
	maus_tilex=(MouseX()+map_scroll_x)/tile_w
	maus_tiley=(MouseY()+map_scroll_y)/tile_h
	
	;Entscheiden, in welchem "Modus" man ist
	If set_player=True Then
		;Bei Tastendruck Spieler platzieren
		If MouseHit(1) Then
			If maus_tilex<=map_width And maus_tiley<=map_height Then ;Sicherheitsabfrage. Kleiner als 0 knnen die Variablen ohnehin nicht sein
				If map_isWalkable(maus_tilex,maus_tiley) Then ;DEBUG - geht ned wenn man sich nicht um Walkable-Objekte kmmert...
					player_tilex=maus_tilex
					player_tiley=maus_tiley
					set_player=False
				EndIf
			EndIf
		EndIf
	Else
		;Bei gedrckter linker Maustaste Map verndern
		If MouseDown(1) Then
			If maus_tilex<=map_width And maus_tiley<=map_height Then ;Sicherheitsabfrage. Kleiner als 0 knnen die Variablen ohnehin nicht sein
				If maus_tilex<>player_tilex Or maus_tiley<>player_tiley Then ;Abfrage, dass Tile unterhalb des Players nicht verndert werden kann (kein Wasser drunter setzen)
					map(maus_tilex,maus_tiley)=ausgew_tile
				EndIf
			EndIf
		EndIf
	EndIf
	
	;Setzen des Spielers einleiten - Taste "P"
	If KeyHit(25) Then
		set_player=True
		FlushMouse()
	EndIf
	
	;Map Speichern
	If KeyHit(31) Then
		FlushKeys()
		file$=Input("Mapname: ")
		FlushKeys()
		SaveMap(file$)
	EndIf
	
	;Map laden
	If KeyHit(38) Then
		FlushKeys()
		file$=Input("Mapname: ")
		FlushKeys()
		LoadMap(file$)
	EndIf
	
	;Zu setzendes Tile auswhlen
	For i=0 To tileset_count-1
		If KeyHit(i+2) Then ausgew_tile=i
	Next
	
	;Mapscrolling mit rechter Maustaste
	If MouseDown(2) Then
		If mausscroll_x<>-1 Then
			;Scrollen
			map_scroll_x=map_scroll_x+(MouseX()-mausscroll_x)/2
			map_scroll_y=map_scroll_y+(MouseY()-mausscroll_y)/2
			;Werte begrenzen
			If map_scroll_x<0 Then map_scroll_x=0
			If map_scroll_y<0 Then map_scroll_y=0
			If map_scroll_x>map_width*tile_w-gfx_width+tile_w Then map_scroll_x=map_width*tile_w-gfx_width+tile_w
			If map_scroll_y>map_height*tile_h-gfx_height+tile_h Then map_scroll_y=map_height*tile_h-gfx_height+tile_h
		Else
			;Punkt festlegen, von wo aus mit der Maus gezogen wird
			mausscroll_x=MouseX()
			mausscroll_y=MouseY()
		EndIf
	Else
		mausscroll_x=-1
	EndIf
	
	;Per Druck auf "R" Rasterlinien umschalten
	If KeyHit(19) Then
		raster=Not raster
	EndIf
End Function

Function DrawGame()
	Map_Draw()
	
	;Player- bzw. Tile-Vorschau
	If set_player Then
		DrawImage gfx_player,maus_tilex*32-map_scroll_x,maus_tiley*32-map_scroll_y
	Else
		DrawImage gfx_player,player_tilex*32-map_scroll_x,player_tiley*32-map_scroll_y
		DrawImage gfx_tileset,maus_tilex*32-map_scroll_x,maus_tiley*32-map_scroll_y,ausgew_tile
	EndIf
	
	;Rasterlinien in Form von Rects einzeichnen, da schneller als mit Line
	If raster Then
		Color 150,150,150
		;Senkrecht
		For x=0 To gfx_width Step 64
			Rect x,0,32,gfx_height,0
		Next
		;Waagrecht
		For y=0 To gfx_height Step 64
			Rect 0,y,gfx_width,32,0
		Next
	EndIf
	
	;Hilfstexte im Editor
	Color 255,255,255
	;Links
	If set_player Then
		Text 10,5,"Spieler-Setzen-Modus"
	Else
		Text 10,5,"Tile-Setzen-Modus"
		Text 10,20,"Mit P gelangt man in den Spieler-Setzen-Modus"
	EndIf
	Text 10,35,"Mausposition: "+maus_tilex+", "+maus_tiley
	
	;Rechts
	Text gfx_width-StringWidth("Rasterlinien mit R umschalten")-10,5,"Rasterlinien mit R umschalten"
	Text gfx_width-StringWidth("Neue Map mit N erstellen")-10,20,"Neue Map mit N erstellen"
End Function

Function Reset()
	Map_Setup()
	
	;Werte zurcksetzen
	map_scroll_x=0
	map_scroll_y=0
	player_tilex=-1
	player_tiley=-1
	set_player=False
End Function



;~IDEal Editor Parameters:
;~C#B3D