;Map-Eigenschaften, werden in der Funktion "NewMap" festgelegt
Global map_scroll_x=0
Global map_scroll_y=0
Global map_width=0
Global map_height=0

Dim map(0,0)

Const tile_w=32
Const tile_h=32

;Tileset laden
Global tileset_count=6
Global gfx_tileset=LoadAnimImage("gfx/tileset.png",tile_w,tile_h,0,tileset_count)

;Verwaltung von (nicht) begehbaren Tiles zur Kollisionsabfrage
Dim map_obstacle(0,0)

Type map_obstacle_tile
	Field id
End Type

Function Map_DefineObstacleTile(tile_id)
	Local t.map_obstacle_tile=New map_obstacle_tile
	t\id=tile_id
End Function

Function Map_SetObstacleTiles()
	Local x,y
	Local t.map_obstacle_tile
	Dim map_obstacle(map_width,map_height) ;Mit 0 initialisieren
	;Zuvor gesetzte Tile-IDs in "Kollisionslayer" eintragen
	For t=Each map_obstacle_tile
		For y=0 To map_height
			For x=0 To map_width
				If map(x,y)=t\id Then
					map_obstacle(x,y)=1
				EndIf
			Next
		Next
	Next
End Function

Function Map_DefineObstacle(x,y)
	map_obstacle(x,y)=1
End Function

Function Map_DefineWalkable(x,y)
	map_obstacle(x,y)=0
End Function

Function Map_IsWalkable(x,y)
	If x<0 Or y<0 Then Return False
	If x>map_width Or y>map_height Then Return False
	Return (map_obstacle(x,y)=0)
End Function

Function Map_Setup(w=-1,h=-1)
	If w<0 Or h<0 Then
		;Abmessungen erfragen. Die Eingabe wird nicht berprft, Fehleingaben daher mglich
		FlushKeys()
		map_width=Int(Input("Gewnschte Map-Breite: "))-1
		map_height=Int(Input("Gewnschte Map-Hhe: "))-1
		FlushKeys()
	Else
		map_width=w
		map_height=h
	EndIf
	Dim map(map_width,map_height)
	Dim map_obstacle(map_width,map_height)
End Function

;Map zeichnen
Function Map_Draw()
	Local x,y
	For y=map_scroll_y/tile_h To map_scroll_y/tile_h+gfx_height/tile_h+1
		If y>map_height Then Exit
		For x=map_scroll_x/tile_w To map_scroll_x/tile_w+gfx_width/tile_w+1
			If x>map_width Then Exit
			DrawBlock gfx_tileset,x*tile_w-map_scroll_x,y*tile_h-map_scroll_y,map(x,y)
		Next
	Next
End Function

Function Map_Scroll()
	;Festlegen der Scroll-Variablen anhand der Spieler-Position
	map_scroll_x=player_x-gfx_width/2
	map_scroll_y=player_y-gfx_height/2
	;Befindet sich der Spieler am Rand der Karte, Scroll-Variablen begrenzen
	If map_scroll_x>map_width*tile_w-(gfx_width-tile_w) Then map_scroll_x=map_width*tile_w-(gfx_width-tile_w)
	If map_scroll_x<0 Then map_scroll_x=0
	If map_scroll_y>map_height*tile_h-(gfx_height-tile_h) Then map_scroll_y=map_height*tile_h-(gfx_height-tile_h)
	If map_scroll_y<0 Then map_scroll_y=0
End Function

;~IDEal Editor Parameters:
;~C#B3D