;NPC-Daten
Type npc
	Field x,y
	Field tile_x,tile_y
	Field state
	Field move,last_move,speed
	Field img
	Field name$
	Field script.script
	Field frame,frame_timer,anim_speed
End Type

Const npc_state_idle=0
Const npc_state_hide=1

;Verfgbare Bilder ermitteln
Global npc_img_count=0
Repeat
	If FileType("gfx/npc/Char_"+(npc_img_count+1)+".png")=1 Then
		npc_img_count=npc_img_count+1
	Else
		Exit
	EndIf
Forever
;... und laden
Dim npc_img(npc_img_count)
For i=0 To npc_img_count-1
	npc_img(i)=LoadAnimImage("gfx/npc/char_"+(i+1)+".png",tile_w,tile_h,0,8)
Next

;Neuen NPC erstellen - Namen und Position automatisch bestimmen
Function NPC_New.npc(name$)
	Local x,y
	Local npc.npc=New npc
	npc\move=move_none
	npc\last_move=move_down
	npc\state=npc_state_idle
	Repeat
		x=Rand(0,map_width)
		y=Rand(0,map_height)
		If Map_IsWalkable(x,y) Then
			npc\tile_x=x
			npc\tile_y=y
			npc\x=x*tile_w
			npc\y=y*tile_h
			Map_DefineObstacle(npc\tile_x,npc\tile_y)
			Exit
		EndIf
	Forever
	npc\name$=name$
	npc\anim_speed=250
	npc\img=npc_img(Rand(1,npc_img_count)-1)
	Return npc
End Function

Function NPC_RemoveByName(name$)
	Local npc.npc
	For npc=Each npc
		If npc\name$=name$ Then
			Map_DefineWalkable(npc\tile_x,npc\tile_y)
			npc\state=npc_state_hide
			Exit
		EndIf
	Next
End Function

Function NPC_SetPosition(name$,x,y)
	Local npc.npc
	For npc=Each npc
		If npc\name$=name$ Then
			Map_DefineWalkable(npc\tile_x,npc\tile_y)
			npc\tile_x=x
			npc\tile_y=y
			npc\x=x*tile_w
			npc\y=y*tile_h
			Map_DefineObstacle(npc\tile_x,npc\tile_y)
			Exit
		EndIf
	Next
End Function

Function NPC_Update()
	Local npc.npc
	For npc=Each npc
		;Pixel-by-tile-scrolling von Spieler bernommen
		If npc\move=move_none Then
			;Wenn nicht gerade eine Bewegung ausgefhrt wird, steuern
			Select npc\state
				Case npc_state_idle
					npc\speed=1
					;Bld herum rennen
					If Rand(0,100)=1 Then
						npc\move=Rand(1,4)
						Select npc\move
							Case move_left
								If Not Map_IsWalkable(npc\tile_x-1,npc\tile_y) Then npc\move=0
							Case move_right
								If Not Map_IsWalkable(npc\tile_x+1,npc\tile_y) Then npc\move=0
							Case move_up
								If Not Map_IsWalkable(npc\tile_x,npc\tile_y-1) Then npc\move=0
							Case move_down
								If Not Map_IsWalkable(npc\tile_x,npc\tile_y+1) Then npc\move=0
						End Select
					EndIf
			End Select
		Else
			;Figur animieren
			If MilliSecs()>npc\frame_timer Then
				npc\frame=Not npc\frame
				npc\frame_timer=MilliSecs()+npc\anim_speed
			EndIf
			
			;Reaktion auf die Bewegungsvariable
			Select npc\move
				Case move_left npc\x=npc\x-npc\speed
				Case move_right npc\x=npc\x+npc\speed
				Case move_up npc\y=npc\y-npc\speed
				Case move_down npc\y=npc\y+npc\speed
			End Select
			
			Map_DefineWalkable(npc\tile_x,npc\tile_y)
			npc\tile_x=npc\x/tile_w
			npc\tile_y=npc\y/tile_h
			Map_DefineObstacle(npc\tile_x,npc\tile_y)
			
			;Feststellen ob Bewegung abgeschlossen ist
			If npc\x Mod tile_w=0 And npc\y Mod tile_h=0 Then
				npc\last_move=npc\move
				npc\move=move_none
			EndIf
		EndIf
	Next
End Function

Function NPC_Dialogue(txt$,decision=False)
	FlushKeys()
	Color 200,200,200
	Rect 0,gfx_height-100,gfx_width,100,1
	Color 0,0,0
	Text 10,gfx_height-90,txt$
	Color 150,150,150
	If decision Then
		Text 10,gfx_height-70,"J=Ja, N=Nein"
		Flip 0
		Repeat
			key=WaitKey()
			If key=106 Or key=110 Then
				Exit
			EndIf
		Forever
		FlushKeys()
		Return (key=106)
	Else
		Text 10,gfx_height-70,"Bitte Taste drcken"
		Flip 0
		WaitKey()
		FlushKeys()
	EndIf
End Function

Function NPC_Draw()
	Local npc.npc
	Local frame
	For npc=Each npc
		If npc\state<>npc_state_hide Then
			If npc\move=0 Then
				frame=(npc\last_move-1)*2+npc\frame
			Else
				frame=(npc\move-1)*2+npc\frame
			EndIf
			DrawImage npc\img,npc\x-map_scroll_x,npc\y-map_scroll_y,frame
		EndIf
	Next
End Function

;~IDEal Editor Parameters:
;~C#B3D