;Spieler-Variablen
Global player_tilex=-1
Global player_tiley=-1
Global player_x=player_tilex*tile_w
Global player_y=player_tiley*tile_h
Global player_move,player_last_move=move_right
Global player_speed=2
Global player_frame=0
Global player_frame_timer=0
Global player_animation_speed=250
Global player_show_inventory=False

;Spieler-Bild
Global gfx_player=LoadAnimImage("gfx/player.png",32,32,0,8)

Function Player_Draw()
	Local frame
	If player_move=0 Then
		frame=(player_last_move-1)*2+player_frame
	Else
		frame=(player_move-1)*2+player_frame
	EndIf
	;Spieler zeichnen
	DrawImage gfx_player,player_x-map_scroll_x,player_y-map_scroll_y,frame
	
	Player_Inventory()
End Function

Function Player_Control()
	Local x,y,npc.npc
	If player_move=move_none Then
		;Wenn nicht gerade eine Bewegung ausgefhrt wird Spieler steuern
		x=player_tilex
		y=player_tiley
		Local move=move_none
		If Not player_show_inventory Then
			;Links
			If player_tilex>0 Then
				If KeyDown(203) Or KeyDown(30) Then
					move=move_left
					x=x-1
				EndIf
			EndIf
			;Rechts
			If player_tilex<map_width And move=move_none Then
				If KeyDown(205) Or KeyDown(32) Then
					move=move_right
					x=x+1
				EndIf
			EndIf
			;Rauf
			If player_tiley>0 And move=move_none Then
				If KeyDown(200) Or KeyDown(17) Then
					move=move_up
					y=y-1
				EndIf
			EndIf
			;Runter
			If player_tiley<map_height And move=move_none Then
				If KeyDown(208) Or KeyDown(31) Then
					move=move_down
					y=y+1
				EndIf
			EndIf
			;Auswertung
			If move<>move_none Then
				If Map_IsWalkable(x,y) Then
					player_move=move
				Else
					player_last_move=move
				EndIf
			EndIf
		EndIf
		
		;Aktion auslsen
		If KeyHit(28) Then
			x=player_tilex
			y=player_tiley
			Select player_last_move
				Case move_left x=x-1
				Case move_right x=x+1
				Case move_up y=y-1
				Case move_down y=y+1
			End Select
			For npc=Each npc
				If npc\tile_x=x And npc\tile_y=y Then
					Script_Start(npc\script\name$,npc)
					Exit
				EndIf
			Next
		EndIf
		
		;Sprinten
		If KeyDown(57) Then
			player_speed=4
			player_animation_speed=100
		Else
			player_speed=2
			player_animation_speed=250
		EndIf
		
		;Inventar
		If KeyHit(23) Then
			player_show_inventory=Not player_show_inventory
		EndIf
	Else
		;Figur animieren
		If MilliSecs()>player_frame_timer Then
			player_frame=Not player_frame
			player_frame_timer=MilliSecs()+player_animation_speed
		EndIf
		
		;Reaktion auf die Bewegungsvariable
		Select player_move
			Case move_left player_x=player_x-player_speed
			Case move_right player_x=player_x+player_speed
			Case move_up player_y=player_y-player_speed
			Case move_down player_y=player_y+player_speed
		End Select
		
		;Feststellen ob Bewegung abgeschlossen ist
		;ACHTUNG! Diese berprfung funktioniert nur solange die Bewegungsgeschwindigkeit ein Teiler von 32, sprich 1,2,4,8 oder 16 ist
		If player_x Mod tile_w=0 And player_y Mod tile_h=0 Then
			player_last_move=player_move
			player_move=move_none
		EndIf
	EndIf
	
	Map_DefineWalkable(player_tilex,player_tiley)
	;Umrechnung von Pixel auf Tile
	player_tilex=player_x/tile_w
	player_tiley=player_y/tile_h
	Map_DefineObstacle(player_tilex,player_tiley)
End Function

Function Player_Inventory()
	If player_show_inventory Then
		Color 150,150,150
		Rect 50,50,gfx_width-100,gfx_height-100
		Color 255,255,255
		Text 60,60,"Gesammelte Ideen:"
		
		y=80
		For a=0 To idea_object_count-1
			For b=0 To idea_action_count-1
				For c=0 To idea_extra_count-1
					If ideas(a,b,c)=1 Then
						Text 65,y,Idea_Get$(a,b,c)
						y=y+20
					EndIf
				Next
			Next
		Next
		
		Text 60,y,"Drcke I, um wieder zurck zum Spiel zu gelangen"
	EndIf
End Function
;~IDEal Editor Parameters:
;~C#B3D