;Datenverwaltung
Type script_manager
	Field script.script
	Field current_line.script_line
	Field timer
	Field owner.npc
End Type

Type script
	Field name$
	Field start.script_line
	Field quest
End Type

Type script_line
	Field funct$
	Field para$[10]
	Field paracount
End Type

Type script_drawing
	Field img
	Field x,y
End Type

Global current_script.script

;Bilder fr Skripte (Markierungen usw)
Global script_marker=CreateImage(tile_w,tile_h)
SetBuffer ImageBuffer(script_marker)
Color 200,0,0
Rect 0,0,32,32,0

Dim script_arrow(90)
script_arrow(0)=CreateImage(tile_w*2,tile_h*2)
MidHandle script_arrow(0)
SetBuffer ImageBuffer(script_arrow(0))
Line tile_w,tile_h,tile_w*2,tile_h
Line tile_w*2,tile_h,tile_w*2-5,tile_h-5
Line tile_w*2,tile_h,tile_w*2-5,tile_h+5
SetBuffer BackBuffer()
For i=1 To 89
	script_arrow(i)=CopyImage(script_arrow(0))
	RotateImage script_arrow(i),i*4
Next
script_arrow(90)=script_arrow(0)

;Sonstiger Kram der die Sache einfacher bzw. komplexer macht...

Const script_break=0
Const script_ok=1
Const script_quit=2

Global script_functs_count=20
Dim script_functs$(script_functs_count)
Dim script_para_count(script_functs_count)
script_functs$(0)="script_include"
script_functs$(1)="script_change"
script_functs$(2)="script_timer"
script_functs$(3)="script_notify"

script_functs$(4)="npc_new"
script_functs$(5)="npc_remove"
script_functs$(6)="npc_dialogue"
script_functs$(7)="npc_leave"
script_functs$(8)="npc_decision"
script_functs$(9)="npc_position"

script_functs$(10)="map_load"
script_functs$(11)="map_edit"

script_functs$(12)="quest_cond_pos"
script_functs$(13)="quest_cond_talk"
script_functs$(14)="quest_jump"

script_functs$(15)="idea_object"
script_functs$(16)="idea_action"
script_functs$(17)="idea_extra"
script_functs$(18)="idea_ready"

script_functs$(19)="player_image"

script_para_count(0)=1
script_para_count(1)=1
script_para_count(2)=2
script_para_count(3)=1
script_para_count(4)=2
script_para_count(5)=1
script_para_count(6)=1
script_para_count(7)=1
script_para_count(8)=2
script_para_count(9)=3
script_para_count(10)=1
script_para_count(11)=3
script_para_count(12)=2
script_para_count(13)=0
script_para_count(14)=1
script_para_count(15)=1
script_para_count(16)=1
script_para_count(17)=1
script_para_count(18)=0
script_para_count(19)=1

Function Script_Load(file$)
	Local reader=ReadFile("script/"+file$)
	If reader=0 Then Return 0
	current_script=Null
	Local txt$=""
	While Not Eof(reader)
		txt$=ReadLine(reader)
		If Instr(txt$,";")>0 Then
			txt$=Left(txt$,Instr(txt$,";")-1)
		EndIf
		txt$=Trim(txt$)
		If txt$<>"" Then
			Script_ParseLine(txt$)
		EndIf
	Wend
	CloseFile reader
	Local sl.script_line
	If current_script<>Null Then
		sl=New script_line
		sl\funct$="[end]"
	EndIf
	;Script_Debug()
	If Script_Validate() Then
		Return 1
	Else
		Return 0
	EndIf
End Function

Function Script_Start.script_manager(name$,npc.npc)
	Local sm.script_manager=New script_manager
	sm\script=Script_GetByName(name$)
	sm\owner=npc
	Return sm
End Function

Function Script_ParseLine(txt$)
	Local sl.script_line
	Local para$
	If Left(txt$,1)="." Then
		If current_script<>Null Then
			sl=New script_line
			sl\funct$="[end]"
		EndIf
		current_script=New script
		current_script\name$=Lower(Right(txt$,Len(txt$)-1))
		sl=New script_line
		sl\funct$="[start]"
		current_script\start=sl
	Else
		If current_script=Null Then
			Script_ParseLine(".init")
		EndIf
		sl=New script_line
		If Instr(txt$," ")>0 Then
			sl\funct$=Trim(Left(txt$,Instr(txt$," ")))
			para$=Right(txt$,Len(txt$)-Instr(txt$," "))
			i=0
			Repeat
				sl\para$[i]=Script_GetPara(para$,i+1)
				sl\para$[i]=Replace(sl\para$[i],"(.)",",")
				If sl\para$[i]="" Or i=9 Then Exit
				i=i+1
			Forever
			sl\paracount=i
		Else
			sl\funct$=txt$
		EndIf
	EndIf
End Function

Function Script_GetPara$(txt$,num)
	Local indexa=0
	For i=1 To num-1
		indexa=Instr(txt$,",",indexa+1)
		If indexa=0 Then
			Return ""
		EndIf
	Next
	Local indexb=Instr(txt$,",",indexa+1)
	If indexb=0 Then
		indexb=Len(txt$)+1
	EndIf
	Return Mid(txt$,indexa+1,indexb-indexa-1)
End Function

Function Script_Update()
	Local sm.script_manager
	Local s.script
	Local ret
	For sm=Each script_manager
		If sm\timer=0 Then
			s=sm\script
			If sm\current_line=Null Then
				sm\current_line=After s\start
			EndIf
			Repeat
				ret=Script_DoCurrent(sm)
				If ret=script_quit Then
					Exit
				EndIf
				sm\current_line=After sm\current_line
			Forever
		Else
			If MilliSecs()>sm\timer Then sm\timer=0
		EndIf
	Next
End Function

Function Script_DoCurrent(sm.script_manager)
	Local npc.npc
	Local s.script=sm\script
	Local sl.script_line=sm\current_line
	Select Lower(sl\funct$)
		Case "script_include"
			Script_Load(sl\para[0])
		Case "script_change"
			Delete Each script
			Delete Each script_line
			Delete Each script_manager
			Script_Load(sl\para[0])
		Case "script_timer"
			sm=Script_Start(sl\para[1],sm\owner)
			sm\timer=MilliSecs()+Int(sl\para[0])
		Case "script_notify"
			DebugLog sl\para[0]
			
			
		Case "npc_new"
			npc=NPC_New(sl\para$[0])
			npc\script=Script_GetByName(sl\para$[1])
		Case "npc_remove"
			NPC_RemoveByName(sl\para$[0])
		Case "npc_dialogue"
			txt$=sl\para$[0]
			If Instr(txt$,"(idee ")>0 Then
				i1=Instr(txt$," ")
				i2=Instr(txt$," ",i1+1)
				i3=Instr(txt$," ",i2+1)
				i4=Instr(txt$,")",i3+1)
				a=Mid(txt$,i1,i2-i1)
				b=Mid(txt$,i2,i3-i2)
				c=Mid(txt$,i3,i4-i3)
				txt$=Idea_Get(a,b,c)
			EndIf
			NPC_Dialogue(sm\owner\name+": "+txt$)
			If Idea_Check() Then
				NPC_Dialogue("Du bist der DEBUG-King!")
			EndIf
		Case "npc_decision"
			If Not NPC_Dialogue(sm\owner\name+": "+sl\para$[0],True) Then
				npc=sm\owner
				Delete sm
				sm=Script_Start(sl\para[1],npc)
				Return script_quit
			EndIf
		Case "npc_position"
			NPC_SetPosition(sl\para[0],sl\para[1],sl\para[2])
			
			
		Case "map_load"
			LoadMap(sl\para[0])
		Case "map_edit"
			x=Int(sl\para[0])
			y=Int(sl\para[1])
			If x>0 And x<map_width Then
				If y>0 And y<map_height Then
					map(x,y)=Int(sl\para[2])
					Map_SetObstacleTiles()
				EndIf
			EndIf
			
			
		Case "quest_cond_pos"
			s\quest=True
			Script_MarkPosition(Int(sl\para[0])*tile_w,Int(sl\para[1])*tile_h)
			If player_tilex=sl\para[0] And player_tiley=sl\para[1] Then
				s\quest=False
			Else
				Return script_quit
			EndIf
		Case "quest_cond_talk"
			s\quest=True
			x=sm\owner\tile_x
			y=sm\owner\tile_y
			Script_MarkPosition(x*tile_w,y*tile_h)
			If player_tilex>=x-1 And player_tilex<=x+1 And player_tiley>=y-1 And player_tiley<=y+1 Then
				s\quest=False
			Else
				Return script_quit
			EndIf
		Case "quest_jump"
			ok=False
			For sm2.script_manager=Each script_manager
				If sm2\script\quest Then
					If sm2<>sm Then
						ok=True
						Exit
					EndIf
				EndIf
			Next
			If ok Then
				npc=sm\owner
				Delete sm
				sm=Script_Start(sl\para[0],npc)
				Return script_quit
			EndIf
			
			
		Case "idea_object"
			Idea_AddObject(sl\para[0])
		Case "idea_action"
			Idea_AddAction(sl\para[0])
		Case "idea_extra"
			Idea_AddExtra(sl\para[0])
		Case "idea_ready"
			Idea_Ready()
			
		Case "player_image"
			FreeImage gfx_player
			gfx_player=LoadAnimImage("gfx/"+sl\para[0],tile_w,tile_h,0,8)
			
		Case "[end]"
			Delete sm
			Return script_quit
	End Select
	Return script_ok
End Function

Function Script_MarkPosition(x,y)
	Script_AddDrawing(script_marker,x,y)
	Local w=ATan2(player_y-y,player_x-x)+180
	Script_AddDrawing(script_arrow(w/4),player_x+tile_w/2,player_y+tile_h/2)
End Function

Function Script_Debug()
	Local s.script,sl.script_line
	For s=Each script
		DebugLog "Script: "+s\name$
		sl=After s\start
		Repeat
			If sl=Null Then Exit
			If sl\funct$="[end]" Then Exit
			DebugLog " Func: "+sl\funct$
			For i=0 To sl\paracount-1
				DebugLog "  Para: "+sl\para$[i]
			Next
			sl=After sl
		Forever
	Next
End Function

Function Script_AddDrawing(img,x,y)
	Local sd.script_drawing=New script_drawing
	sd\img=img
	sd\x=x
	sd\y=y
End Function

Function Script_Draw()
	Local sd.script_drawing
	For sd=Each script_drawing
		DrawImage sd\img,sd\x-map_scroll_x,sd\y-map_scroll_y
		Delete sd
	Next
End Function

Function Script_Validate()
	Local s.script,s2.script
	Local sl.script_line
	Local funct_ok,para_ok
	For s=Each script
		If s\name$="" Then
			DebugLog "Script Error: Need Script-Identifier"
			Return 0
		EndIf
		s2=After s
		While s2<>Null
			If s\name$=s2\name$ Then
				DebugLog "Script Error: Script-Identifier "+s\name$+" occours more than once"
				Return 0
			EndIf
			s2=After s2
		Wend
		sl=After s\start
		Repeat
			If sl=Null Then Exit
			If sl\funct$="[end]" Then Exit
			funct_ok=False
			para_ok=False
			
			For i=0 To script_functs_count-1
				If Lower(sl\funct$)=script_functs$(i) Then
					funct_ok=True
					If sl\paracount=script_para_count(i) Then
						para_ok=True
					EndIf
					Exit
				EndIf
			Next
			If Not funct_ok Then
				DebugLog "Script Error: Function '"+sl\funct$+"' not found"
				Return 0
			EndIf
			If Not para_ok Then
				DebugLog "Script Error: Function '"+sl\funct$+"' needs exactly "+script_para_count(i)+" parameter"
				Return 0
			EndIf
			
			;Nicht so einfach zu handhaben wegen script_include... also lass ma das mal
			
;			If sl\funct$="npc_new" Or sl\funct$="script_timer" Then
;				sl\para$[1]=Lower(sl\para$[1])
;				s2=Script_GetByName(sl\para$[1])
;				If s2=Null Then
;					DebugLog "Script Error: Script-ID '"+sl\para$[1]+"' not found"
;					Return 0
;				EndIf
;			EndIf
;			If sl\funct$="quest_jump" Then
;				sl\para$[0]=Lower(sl\para$[0])
;				s2=Script_GetByName(sl\para$[0])
;				If s2=Null Then
;					DebugLog "Script Error: Script-ID '"+sl\para$[0]+"' not found"
;					Return 0
;				EndIf
;			EndIf
			If sl\funct$="script_include" Or sl\funct$="script_change" Then
				If FileType("script/"+sl\para$[0])=0 Then
					DebugLog "Script Error: Script-file '"+sl\para$[0]+"' not found"
					Return 0
				EndIf
			EndIf
			sl=After sl
		Forever
	Next
	Return 1
End Function

Function Script_GetByName.script(name$)
	Local s.script
	For s=Each script
		If s\name$=name$ Then
			Return s
		EndIf
	Next
	Return Null
End Function
;~IDEal Editor Parameters:
;~C#B3D