;BCC#53 - Mechschlacht;

;Start: 24.07.2011
;Angeplantes Ziel: Ein 3D Spiel, in dem man entweder aus dem1 Cockpit heraus oder Rckenperspektive einen Mech steuert.
;Der Mech hat dabei mehrere Waffenslots, zu Anfang nur 2 leichte, die dann nach und nach aufgebessert werden knnen.

;Im Kampffeld kann man dabei Munition von zerstrten gegnerischen Einheiten aufsammeln - sofern man die Waffe fr den
;Munitionstyp besitzt. Gegner knnten auch Geldeinheiten abwerfen, die man wiederum fr neue Upgrades oder Waffen bentigt.

;Missionen wrden daraus bestehen, eine Hauptgegnergruppe zu zerstren, seien es alleine Gegner oder Gebude, oder auch
;Beschtzungsmissionen von Gebuden, die Wellenweise von Gegnern angegriffen werden.
;Dazu knnte man noch nebenschlich Gegnerlager aufstellen, die aber nicht zerstrt werden mssen, aber dafr Punkte bringen.

;Generell wre toll: Zerstrbare Gegend, auer Terrain, sodass man Gebude (oder auch nur teilweise? :D) wie Bume zerklumpen kann!


;"Gegner" sind entweder unbewegliche Gebude, unbewegliche Trme mit Geschtzen oder bewegliche Panzereinheiten mit Geschtzen.
;Interessant wren Gegner mit mehr als nur einem G-Sch\Gescheschtz, z.B. ein Panzer mit Raketen, MG und Kanonen als Superpanzer ;O
;Bei beweglichen Panzern wre natrlich eine Art Wegpunkte System ntzlich, sodass sie bestimmte Strecken patroullieren knnen.

Graphics3D 640,480,32,2
AppTitle "Mechschlacht"

Global Font_KL=LoadFont("fixedsys",20)
Global Font_MT=LoadFont("fixedsys",30)
Global Font_GR=LoadFont("fixedsys",60)

Global Font_Menu=LoadFont("Verdana",20,1)

Global Menu=LoadImage("gfx/Menu.png"),MenuModus=0

;SZENE;
	;KAMERA;
		
		Global KamPiv=	CreatePivot()
		Global Kam=		CreateCamera(kamPiv)
		
			;Kameraoberflche;
				
				Global KamLayer=CreateMesh(Kam)
					MoveEntity KamLayer,0,0,1.1
					
					EntityFX KamLayer,1+4+8
					EntityBlend KamLayer,3
					EntityOrder KamLayer,-2
					
					
					surf=CreateSurface(KamLayer)
					
					x#=1.1
					y#=0.825
					u#=0.625
					v#=0.9375
					
					v0=AddVertex(surf,-x,y,0	,0,0)
					v1=AddVertex(surf,x,y,0		,u,0)
					v2=AddVertex(surf,x,-y,0	,u,v)
					v3=AddVertex(surf,-x,-y,0	,0,v)
					
					AddTriangle(surf,v0,v1,v2)
					AddTriangle(surf,v0,v2,v3)
					
					;Multiplizierend
					Global KamLayerMulti=CopyEntity(KamLayer,Kam)
						EntityOrder KamLayerMulti,-1
						EntityBlend KamLayerMulti,2
				
				Global KamTex[7]
					KamTex[0]=CreateTexture(1024,512);Text
						TextureBlend KamTex[0],2
						EntityTexture KamLayer,KamTex[0],0,0
						
					KamTex[1]=CreateTexture(1024,512);Raster
						TextureBlend KamTex[1],3
						EntityTexture KamLayer,KamTex[1],0,1
							;SetBuffer TextureBuffer(KamTex[1])
							;	DrawBlock LoadImage("gfx/raster.png"),0,0
							;SetBuffer BackBuffer()
						
					KamTex[2]=CreateTexture(1024,512);Farbe
						TextureBlend KamTex[2],2
						EntityTexture KamLayer,KamTex[2],0,2
						
				Global KamTexMulti=CreateTexture(1024,512)
					EntityTexture KamLayerMulti,KamTexMulti
					
			;Kameraoberflche
					
	;KAMERA;
	
	;LEVEL;
	
		Global lvlLicht=CreateLight();Sonne
			RotateEntity lvlLicht,22.5,45,0
			
			;AmbientLight 255,255,255
		
		;Global lvlTerrain=LoadTerrain("gfx/karte.png")
		;	TerrainShading 	lvlTerrain,1
		;	TerrainDetail 	lvlTerrain,50000,1
		;	
		;	ScaleEntity lvlTerrain,0.5,32,1
		;
		;		Global lvlTerrainTex=LoadTexture("gfx/kartefar.png")
		;			ScaleTexture lvlTerrainTex,512,512
		;			EntityTexture lvlTerrain,lvlTerrainTex,0,0
		;		
		;		Global lvlTerrainDetail=LoadTexture("gfx/kartedet.png")
		;			EntityTexture lvlterrain,lvlTerrainDetail,0,1
	;LEVEL;
	
	;KOLLISION
			;Kollisionskonsten + Kollision
		
		Global KOLL_WELT	=1
		
		Global KOLL_ICH		=2
		Global KOLL_GEGNER	=3
		
		Global KOLL_SCHUSS	=4
		
		Global KOLL_HAUSTOT	=5
		
		
		Collisions KOLL_ICH		,KOLL_WELT	,2,2
		Collisions KOLL_ICH		,KOLL_GEGNER,1,2
		Collisions KOLL_ICH		,KOLL_SCHUSS,1,1
		
		Collisions KOLL_GEGNER	,KOLL_WELT	,2,3
		Collisions KOLL_GEGNER	,KOLL_ICH	,2,2
		Collisions KOLL_GEGNER	,KOLL_GEGNER,2,2
		Collisions KOLL_GEGNER	,KOLL_SCHUSS,1,1
		
		Collisions KOLL_SCHUSS	,KOLL_ICH	,1,1
		Collisions KOLL_SCHUSS	,KOLL_GEGNER,2,1
		Collisions KOLL_SCHUSS	,KOLL_WELT	,2,1
		
		;WireFrame 1
	;KOLLISION
;SZENE;



;INCLUDES;
	
	Include "includes/ich.bb"
		NeuSonne
	Include "includes/waffen.bb"	
	Include "includes/gegner.bb"
	Include "includes/level.bb"
		
	Include "includes/partikel.bb"
		Global Partikel_Staub.PartikelInfo=NeuPartikelInfo(8,15000,0.001,0.1,$483a28,$d0c4a3,$000000)
			Global PaIf_StaubTex=LoadTexture("Gfx/Staub.png",1+64)
				EntityTexture Partikel_Staub\Mesh,PaIf_StaubTex
				EntityBlend Partikel_Staub\Mesh,3
				EntityFX Partikel_Staub\Mesh,1+8+16
				
		;Explosionsgedns!
				
		Global Partikel_Feuer.PartikelInfo=NeuPartikelInfo(4,10000,0.0001,0.05,$e8db6e,$f9bd1c,$cd5e48)
			;Global PaIf_FeuerTex=LoadTexture("Gfx/Staub.png",1+64)
				EntityTexture Partikel_Feuer\Mesh,PaIf_StaubTex
				EntityBlend Partikel_Feuer\Mesh,3
				EntityFX Partikel_Feuer\Mesh,1+8+16
				
		Global Partikel_Rauch.PartikelInfo=NeuPartikelInfo(8,30000,0.0005,0.01,$ffffff,$ffffff,$ffffff)
			Global PaIf_RauchTex=LoadTexture("Gfx/Rauch.png",1+64)
				EntityTexture Partikel_Rauch\Mesh,PaIf_RauchTex
				EntityBlend Partikel_Rauch\Mesh,2
				EntityFX Partikel_Rauch\Mesh,1+8+16
		
		;Blut!!!
		
		Global Partikel_Blut.PartikelInfo=NeuPartikelInfo(1,5000,-0.01,0.25,$ffffff,$ffffff,$ffffff)
			Global PaIf_BlutTex=LoadAnimTexture("Gfx/Blut.png",1+64,64,64,0,4)
				EntityBlend Partikel_Blut\Mesh,2
				EntityFX Partikel_Blut\Mesh,1+8;+16
		
		;Belohnungsgetier
		
		Global Partikel_Stern.PartikelInfo=NeuPartikelInfo(1,5000,-0.01,0.25,$000000,$ffff80,$000000)
			Global PaIf_SternTex=LoadTexture("Gfx/Stern.png",1+64)
				EntityTexture Partikel_Stern\Mesh,PaIf_SternTex
				EntityBlend Partikel_Stern\Mesh,3
				EntityFX Partikel_Stern\Mesh,1+8+16
	
	SetBuffer BackBuffer()
;INCLUDES;



;GLOBAL;
	
	Global glMouseX,glMouseY,glMouseH[2],glMouseD[2],glFPS=CreateTimer(60)
	
;GLOBAL;


;HAUPT;


;Eigentliches Spiel:


;EndeLevel 1

IchWfL=IDWaffe("G",0)
	IchWfL\Gekauft=1
	ShowEntity IchWfL\Mesh
IchWfR=IDWaffe("MG",1)
	IchWfR\Gekauft=1
	ShowEntity IchWfR\Mesh

IchLeben=IchLebenMax
IchZiele=0
IchZieleMax=0
IchGeld=5000

Menu

;---


Function Spiel()
	
	;NeuLevel
	
	FlushKeys
	FlushMouse
	
	SetBuffer BackBuffer()
	
	Repeat
		WaitTimer glFPS
		Cls
		Upd
			DrawBlock Menu,0,0
			
			;Steuerung, Gedns:
				
				SetFont Font_GR
			
				Color 0,255,255
			Text 320, 80,"Mechschlacht",1,1
				
				
				Blink#=Sin( (MilliSecs() Mod 1000) / 1000.0 * 180 )
				
				Color 0,Blink*127+128,Blink*127+128
				SetFont Font_MT
			Text 320,140,"Beliebige Taste drcken!",1,1
			
				SetFont Font_KL
				Color 0,255,255
			Text 320,180,"Missionsbriefing:",1
				Color 0,192,192
			Text 60,200,"Sammle die Ziele, die in dem Einsatzgebiet verteilt sind!"
			Text 60,220,"Sammle Bonusziele, wenn mglich!"
			Text 60,240,"Vernichte Gegner , wenn ntig!!!"
			Text 60,260,"Gegner die aufleuchten verbergen (Bonus-)Ziele!"
			Text 60,280,"Zerstrte Gegner bringen Geld und Leben oder Munition!"
			
				Color 0,255,255
			Text 320,320,"Steuerung:",1
				Color 0,255,255
				Text 50 + 60,340,"Laufen:"
					Color 0,255,0
					Text 50 + 120,340,"[W] [S]"
				
				Color 0,255,255
				Text 50 + 200,340,"Drehen:"
					Color 0,255,0
					Text 50 + 260,340,"[A] [D]"
				
				Color 0,255,255
				Text 50 + 360,340,"Umschauen:"
					Color 0,255,0
					Text 50 + 440,340,"[Maus]"
				
				Color 0,255,255
				Text 50 + 60,360,"Schieen:"
					Color 0,255,0
					Text 50 + 140,360,"[L./R. Maustaste]"
				
				Color 0,255,255
				Text 50 + 300,360,"Waffenmen:"
					Color 0,255,0
					Text 50 + 400,360,"[Leertaste]"
			
				Color 0,255,255
			Text 320,400,"Farbcodes der Ziele:",1
			
				Color 0,255,128
			Text 120,420,"[Zivilist]",1
			
				Color 0,128,255
			Text 320,420,"[Aktenkoffer]",1
			
				Color 255,128,0
			Text 520,420,"[Bonus]",1
			
		
		Flip 0
	Until GetKey()
	
	FlushKeys
	FlushMouse
	
	Repeat
		WaitTimer glFPS
		Cls
		Upd
		
		If IchMenu
		
			IchMenu()
		
		Else;KEIN MEN;	
		
		
		
		UpdIch
		
		WaffeIch
		
		UpdGegner
		
		UpdZiel
		
		UpdGeschuetz
		
		UpdSchuss
		
		UpdObj
		
		UpdPartikel
	
		
			;Himmel
			RotateEntity KamHimmel,0,0,0,1
			
		UpdSonne
		
		
		UpdateWorld
	
		MalIch
		
		;!!!DEBUGKARTE!!!;
	;	For y=0 To 15
	;		For x=0 To 15
	;			
	;			Map=Lvl_Karte(x,y)
	;			Col=$FF0000
	;			
	;			If Map=1
	;				Col=$00FF00
	;			ElseIf Map=2
	;				Col=$D0D0D0
	;			EndIf
	;			
	;			Color 0,0,col
	;			
	;			Rect x*10,y*10,10,10
	;			
	;			Color 0,0,0
	;			
	;			Select Lvl_Strasse(x,y)
	;				Case 0
	;				Default
	;					Text x*10,y*10,"+"
	;			End Select
	;			
	;			Select Lvl_Stadt(x,y)
	;				Case 0
	;				Default
	;					Rect x*10,y*10,10,10
	;					Color 255,255,255
	;					Text x*10,y*10,Lvl_Stadt(x,y);"X"
	;			End Select
	;			
	;			
	;		Next
	;	Next
		
		;Text 0,0,ObjSichtbar
		ObjSichtbar=0
	
		If KeyHit(57) Then IchMenu=1;MEN aktivieren!
			
		EndIf
		
		If KeyHit(1)
			MenuModus=0
			Exit
		ElseIf IchLeben=<0
			MenuModus=-1;Verloren!
			IchGeld=IchGeld * 0.5
			Exit
		ElseIf IchZiele=IchZieleMax
			MenuModus=1;Gewonnen!
			Exit
		EndIf
		
		Flip 0
	Forever
	
	EndeLevel
	
	FlushKeys
	FlushMouse
	
	ShowPointer
	
End Function

;HAUPT;



;GLOBAL;

Function Upd();Maus und co.
	
	glMouseX=MouseX()
	glMouseY=MouseY()
	
	For i=0 To 2
		glMouseH[i]= MouseHit(i+1)
		glMouseD[i]=MouseDown(i+1)
	Next
	
End Function

Function Menu()
	
	Repeat
		WaitTimer glFPS
		Cls
		DrawBlock Menu,0,0
		
			Color 0,255,255
			SetFont Font_GR
		Text 320,80,"Mechschlacht",1,1
			
			SetFont Font_KL
		Text 320,120,"von "+Chr(34)+"Fredko"+Chr(34)+" fr den BCC #53 "+Chr(34)+"Sammeln"+Chr(34),1,1
			
		Upd
		
		;Menu;
			Select MenuModus
				Case 0
					
				Case 1
					;SIEG;
						SetFont Font_GR
						Color 255,255,0
					Text 320,240,"SIEG",1,1
					
						SetFont Font_KL
						Color 192,192,0
					Text 320,280,"Applaus! Du hast alle Ziele einsammeln knnen!",1
					Text 320,300,"Bereit fr eine weitere Runde?",1
					Text 320,320,"Du hast immerhin "+IchGeld+"$ brig!",1
					
					;Text 320,360,"Zudem ist jede Spielrunde einzigartig generiert!",1
					;Text 320,380,"Keine Spielpartie ist gleich ... hoffentlich!",1
					
				Case -1
					;NIEDERLAGE;
						SetFont Font_MT
						Color 255,0,0
					Text 320,240,"Niederlage",1,1
					
						SetFont Font_KL
						Color 192,0,0
					Text 320,260,"Die Mission ist gescheitert.",1
					Text 320,280,"Willst du es in einem anderem Gebiet versuchen?",1
					Text 320,300,"Dazu hast du "+IchGeld+"$ Startbudget!",1
			End Select
		
		;Startknopf
			SetFont Font_GR
			Color 0,128,128
			
			If glMouseX >= 200 And glMouseX < 440 And glMouseY >= 160 And glMouseY < 220
				Color 0,255,255
				
				;Starten!
				If glMouseH[0]
					HidePointer
					
					NeuLevel
					
					Spiel
				EndIf
				
			EndIf
			
			Text 320,160,"<START>",1
			
			
		;Endknopf
			SetFont Font_GR
			Color 128,0,0
			
			If glMouseX >= 200 And glMouseX < 440 And glMouseY >= 360 And glMouseY < 420
				Color 255,0,0
				
				;Starten!
				If glMouseH[0]
					End
				EndIf
				
			EndIf
			
			Text 320,360,"<ENDE>",1
		
		If KeyHit(2) Then Spiel
		
		Flip 0
	Until KeyHit(1)
	End
End Function

;HSV ... nicht aus Fredkasino! NEIN! D:

Function HSVhex(h#,s#,v#);Selbstgemacht! ;o
	Local rf#,gf#,bf#,r,g,b,hexrgb
	
	Local hh#=h/60
	Local c#=v*s
	Local x#=c*(1-Abs((hh Mod 2) -1))
	
	If 0=<hh And hh<1
		rf=c
		gf=x
		bf=0
	ElseIf 1=<hh And hh<2
		rf=x
		gf=c
		bf=0
	ElseIf 2=<hh And hh<3
		rf=0
		gf=c
		bf=x
	ElseIf 3=<hh And hh<4
		rf=0
		gf=x
		bf=c
	ElseIf 4=<hh And hh<5
		rf=x
		gf=0
		bf=c
	ElseIf 5=<hh And hh<6
		rf=c
		gf=0
		bf=x
	EndIf
	
	Local m#=v-c
		
	r=(rf+m)*255
	g=(gf+m)*255
	b=(bf+m)*255
	
	hexrgb=r*$10000+g*$100+b
	
	Return hexrgb
End Function

Function HSVr(h#,s#,v#)
	Return (HSVhex(h,s,v) And $FF0000)/$10000
End Function

Function HSVg(h#,s#,v#)
	Return (HSVhex(h,s,v) And $FF00)/$100
End Function

Function HSVb(h#,s#,v#)
	Return (HSVhex(h,s,v) And $FF)
End Function


;HEX Farben

Function HEXr(RGB)
	Return (RGB And $FF0000)/$10000
End Function

Function HEXg(RGB)
	Return (RGB And $FF00)/$100
End Function

Function HEXb(RGB)
	Return (RGB And $FF)
End Function

Function MoveUV(Mesh,U#,V#)
	
	;Surfaces durchgehen
	
	For i=1 To CountSurfaces(Mesh)
		
		Surf=GetSurface(Mesh,i)
		
		;Vertices durchgehen
		
		For j=0 To CountVertices(Surf)-1
			
			;UV verschieben
			
				altU#=VertexU(Surf,j)
				altV#=VertexV(Surf,j)
				
				VertexTexCoords Surf,j,altU + U,altV + V
				
		Next
		
	Next
End Function

Function ScaleUV(Mesh,U#,V#)
	
	;Surfaces durchgehen
	
	For i=1 To CountSurfaces(Mesh)
		
		Surf=GetSurface(Mesh,i)
		
		;Vertices durchgehen
		
		For j=0 To CountVertices(Surf)-1
			
			;UV verschieben
			
				altU#=VertexU(Surf,j)
				altV#=VertexV(Surf,j)
				
				VertexTexCoords Surf,j,altU * U,altV * V
				
		Next
		
	Next
End Function

;GLOBAL;