
Type TControl 'Klasse in der die individuellen Tastaturbelegungen gespeichert werden
	Global sINIPath:String = "Data/bin/Controls.ini"
	'*Bewegung*
	Field iForward:Int
	Field iBackward:Int
	Field iTurnLeft:Int
	Field iTurnRight:Int
	'*Aktionen*
	Field iShoot:Int
	
	Function Create:TControl(iControls:Int[]) 'Konstruktor mit allen Tasten
		Local Control:TControl = New TControl
		
		Control.iForward = iControls[0]
		Control.iBackward = iControls[1]
		Control.iTurnLeft = iControls[2]
		Control.iTurnRight = iControls[3]
		Control.iShoot = iControls[4]
		
		Return Control
	End Function
	
	Function CreateFromINI:TControl(sSection:String) 'Konstruktor durch INI Datei
		Local Control:TControl = New TControl
		
		Control.iForward = Int(SearchInFile(sSection, "Forward", sINIPath))
		Control.iBackward = Int(SearchInFile(sSection, "Backward", sINIPath))
		Control.iTurnLeft = Int(SearchInFile(sSection, "Turnleft", sINIPath))
		Control.iTurnRight = Int(SearchInFile(sSection, "Turnright", sINIPath))
		Control.iShoot = Int(SearchInFile(sSection, "Shoot", sINIPath))
		
		Return Control
	End Function
	
	Method SaveControls(sSection:String) 'Speichert neue Tastaturbelegung ab
		WriteCompleteFile(sSection, "Forward", iForward, sINIPath)
		WriteCompleteFile(sSection, "Backward", iBackward, sINIPath)
		WriteCompleteFile(sSection, "Turnleft", iTurnLeft, sINIPath)
		WriteCompleteFile(sSection, "Turnright", iTurnright, sINIPath)
		WriteCompleteFile(sSection, "Shoot", iShoot, sINIPath)
	End Method
End Type

