﻿Type TMyGraphics
	Global sINIPath:String = "Data/bin/INIs/Graphics.ini"
	Global v2DSolution:TVector2D
	Global iMaxSolutions:Int
	Global iPossibleXSolutions:Int[], iPossibleYSolutions:Int[]
	Global iSelectedSolution:Int
	Global bFullscreen:Byte
	
	Global timFTimer:TTImer
	Global iMSC:Int, iLasttime:Int, iTime:Int
	
	Global iScreenWidth:Int, iScreenHeight:Int
	Global iScreenWidthHalf:Int, iScreenHeightHalf:Int
		
	Function SetSolution() 'Mach die Änderung der Auflösung wirksam
		Local Font:TImageFont = GetImageFont()
		EndGraphics()
		
		Print "Selected: " + v2DSolution.Get_x() + " | " + v2DSolution.Get_y()
		
		If bFullscreen Then
			(Graphics(v2DSolution.Get_X(), v2DSolution.Get_Y(), 32))
			SetBlend(ALPHABLEND)
		Else
			(Graphics(v2DSolution.Get_X(), v2DSolution.Get_Y()))
			SetBlend(ALPHABLEND)
		EndIf
		
		iSCREENWIDTH = GraphicsWidth()
		iSCREENHEIGHT = GraphicsHeight()
		iScreenWidthHalf = iScreenWidth / 2
		iScreenHeightHalf = iScreenHeight / 2
		SetImageFont(Font)
		
	End Function
	
	Function ChangeSolution()
		While (iPossibleXSolutions[iSelectedSolution] = 0)
			iSelectedSolution = (iSelectedSolution + 1) Mod iMaxSolutions
		Wend
		v2DSolution.Set_X(iPossibleXSolutions[iSelectedSolution])
		v2DSolution.Set_Y(iPossibleYSolutions[iSelectedSolution])
	End Function
	
	Function Update() 'Updated die Zeit- und Framerate, wartet auf den Frametimer
		WaitTimer(timFTimer)
		iLasttime = iTime
		itime = MilliSecs()
		iMSC = iTime - iLasttime
	End Function
	
	Function SearchCurrentSolutionnumber() 'Nummer der gewählten Auflösung suchen
		For Local i:Int = 0 Until iMaxSolutions
			If iPossibleXSolutions[i] = v2DSolution.Get_X() Then
				If iPossibleYSolutions[i] = v2DSolution.Get_Y() Then
					iSelectedSolution = i
				End If
			End If
		Next
	End Function
	
	Function SaveStandard() 'Speichert die neuen Standardeinstellungen in der Datei
		WriteCompleteFile("Standard", "XSolution", Int(v2DSolution.Get_X()), sINIPath)
		WriteCompleteFile("Standard", "YSolution", Int(v2DSolution.Get_Y()), sINIPath)
		WriteCompleteFile("Standard", "Fullscreen", bFullscreen, sINIPath)
	End Function
	
	Function SearchCurrentSolution:Int()
		For Local index:Int = 0 Until iPossibleXSolutions.Length
			If iPossibleXSolutions[index] = DesktopWidth() Then
				If iPossibleYSolutions[index] = DesktopHeight() Then
					Return index
				End If
			End If
		Next
	End Function
	
	Function Init(bForce:Byte = False) 'Initialisiert die Graphik über die .INI Datei
		For Local mode:TGraphicsMode = EachIn GraphicsModes()
   			'Print mode.width + "," + mode.height + "," + mode.depth + "," + mode.hertz
		Next
		
		iMaxSolutions = Int(SearchInFile("Maininfos", "Maxsolutions", sINIPath))
	
		iPossibleXSolutions = New Int[iMaxSolutions]
		iPossibleYSolutions = New Int[iMaxSolutions]
		
		For Local i:Int = 1 To iMaxSolutions
			iPossibleXSolutions[i - 1] = Int(SearchInFile("Possible Solutions", "X" + i, sINIPath))
			iPossibleYSolutions[i - 1] = Int(SearchInFile("Possible Solutions", "Y" + i, sINIPath))
		Next
		
		If Not bForce Then
			For Local i:Int = 0 Until iMaxSolutions
				Local bFound:Byte = False
				For Local mode:TGraphicsMode = EachIn GraphicsModes()
					If (iPossibleXSolutions[i] = Int(mode.width)) Then
						If (iPossibleYSolutions[i] = Int(mode.height)) Then
							bFound = True
						EndIf
					End If
					If iPossibleXSolutions[i] = DesktopWidth() Then
						If iPossibleYSolutions[i] = DesktopHeight() Then
							bFound = True
						End If
					End If
				Next
				If bFound = False Then
					iPossibleXSolutions[i] = 0
					iPossibleYSolutions[i] = 0
				Else
				'	Print iPossibleXSolutions[i] + " | " + iPossibleYSolutions[i]
				EndIf
			Next
		EndIf

		'Standardauflösung als momentane festlegen
		v2DSolution = TVector2D.Create(Float(SearchInFile("Standard", "XSolution", sINIPath)), Float(SearchInFile("Standard", "YSolution", sINIPath)))
		
		If Not bForce Then
			If Not GraphicsModeExists(Int(v2DSolution.Get_x()), Int(v2DSolution.Get_Y())) Then
				v2DSolution.Set_x(iPossibleXSolutions[0])
				v2DSolution.Set_y(iPossibleYSolutions[0])
				SaveStandard()
			End If
		EndIf
		
		'Print "Stand: " + v2DSolution.Get_X() + " | " + v2DSolution.Get_Y()
		
		If (SearchInFile("Standard", "Fullscreen", sINIPath) = True) Then
			bFullscreen = True
		Else
			bFullscreen = False
		EndIf
		
		timFTimer = TTimer.Create(60)
		
		?Win32
		SetGraphicsDriver D3D9Max2DDriver()
		?
		
		
		
		SetSolution()
	End Function
End Type