Type TMapPack
	Global tlAllMapPacks:TList = New TList
	Global sINIPath:String = "Data/bin/INIs/MapPacks.ini"
	Global sPath:String = "Data/bin/Maps/"
	Field sName:String
	Field tlUsedMapNames:TList
	
	Method New()
		tlAllMapPacks.AddLast(Self)
	End Method
	
	Function Create:TMapPack(psName:String)
		Local MapPack:TMapPack = New TMapPack
		
		MapPack.sName = psName
		MapPack.tlUsedMapNames = New TList
		MapPack.ReadDirectory()
		MapPack.tlUsedMapNames.Sort()
	'	MapPack.PrintAll()
		
		Return MapPack
	End Function
	
	Function INIT()
		Local tsFile:TStream = ReadFile(sinipath)
		Repeat
			If Not Eof(tsFile) Then
				Local sName:String = ReadLine(tsfile)
				If FileType(sPath + sName) = 2 Then
					TMapPack.Create(sName)
				End If
			EndIf
		Until Eof(tsFile)
	End Function
	
	Method ReadDirectory()
		Local iDir:Int = ReadDir(spath + sName)
		Local sFile:String
		Repeat
			sFile = NextFile(iDir)
			If (Right(sFile, Len("mmp")) = "mmp") Then
				tlUsedMapNames.AddLast(sFile)
			EndIf
		Until sFile = ""
	End Method
	
	Method PrintAll()
		For Local sString:String = EachIn tlUsedMapNames
			DebugLog sString
		Next
	End Method
	
	Function GetMapPack:TMapPack(psName:String)
		For Local Pack:TMapPack = EachIn tlAllMapPacks
			If Pack.sName = psName Then Return Pack
		Next
	End Function
	
	Method GetMap:TGamemap(iNumber:Int)
		Local index:Int = 0
		If (iNumber + 1) <= tlUsedMapNames.Count() Then
			For Local psName:String = EachIn tlUsedMapNames
				If index = iNumber Then
					DebugLog sPath + sName +"/"+ psName
					Return TGameMap.LoadMap(sPath + sName + "/" + psName)
				End If
				index = index + 1
			Next
		EndIf
	End Method
	
	Method AddMap(pMap:TGameMap, psName:String)
		tlUsedMapNames.AddLast(psName)
		pMap.SaveMap(sPath + psName)
	End Method
	
	Method RemoveMap(psName:String)
		DeleteFile(sPath + psName)
	End Method
End Type