Type TPlayer
	Field v2dPositionReal:TVector2D
	Field v2dPositionMap:TVector2D
	Field tdiDrawImage:TDrawnImage
	Field tdiLight:TDrawnImage
	Field fSpeed:Float
	Field bHasWater:Byte
	Field bHasFire:Byte
	Field bHasWind:Byte
	Field bHasEarth:Byte
	Field bHasKey:Byte
	
	Function Create:TPlayer(pv2dMapPos:TVector2D)
		Local Player:TPlayer = New TPlayer
		
		Player.v2dPositionMap = TVector2D.Create(pv2dMapPos.Get_X(), pv2dMapPos.Get_Y())
		Local RealPos:TVector2D = TGameMap.CalculateRealPosition(pv2dMapPos)
		Player.v2dPositionReal = TVector2D.Create(RealPos.Get_X() + TGameMap.iTILESIZE / 2,  ..
												 RealPos.Get_Y() + TGameMap.iTILESIZE / 2)
		Player.fSpeed = 2.75
		Player.bHasEarth = False
		Player.bHasFire = False
		Player.bHasWater = False
		Player.bHasWind = False
		Player.bHasKey = False
										
		Player.tdiDrawImage = TDrawnImage.Create(TLoadedImage.GetImage("PlayerImage"))
		Player.tdiLight = TDrawnImage.Create(TLoadedImage.GetImage("LightImage"))
												
		Return Player
	End Function
	
	Function Init()
		TLoadedImage.Create("Data/gfx/Player/Player.png", "PlayerImage")
		TLoadedImage.Create("Data/gfx/Player/Light.png", "LightImage")
	End Function
	
	Method SetPosition(pv2dPos:TVector2D)
		v2dPositionMap = TVector2D.Create(pv2dPos.get_X(), pv2dPos.Get_Y())
		Local RealPos:TVector2D = TGameMap.CalculateRealPosition(pv2dPos)
		v2dPositionReal = TVector2D.Create(RealPos.Get_X() + TGameMap.iTILESIZE / 2,  ..
										RealPos.Get_Y() + TGameMap.iTILESIZE / 2)
	End Method
	
	Method Reset()
		bHasEarth = False
		bHasFire = False
		bHasWater = False
		bHasWind = False
		bHasKey = False
	End Method
	
	Method Draw()
		Local RealV2d:TVector2D = TVector2D.Create(v2dPositionReal.get_X(), v2dPositionReal.get_Y())
'		RealV2d.Set_X(RealV2d.Get_X() + TGameMap.iTILESIZE / 2)
'		RealV2d.Set_y(RealV2d.Get_y() + TGameMap.iTILESIZE / 2)
		tdiDrawImage.Draw(RealV2d)
	End Method
	
	Method Move()
		Local v2dNewRealPos:TVector2D = TVector2d.Create(v2dPositionReal.Get_X(), v2dPositionReal.get_Y())
		Local v2dNewMapPos:TVector2D = TVector2d.Create(v2dPositionMap.Get_X(), v2dpositionmap.Get_Y())
		Local v2dRealForMap:TVector2D = TVector2d.Create(v2dPositionReal.Get_X(), v2dPositionReal.get_Y())
		If KeyDown(KEY_LEFT) Then
			v2dNewRealPos.Set_X(v2dNewRealPos.Get_X() - fSpeed)
			v2dRealForMap.Set_X(v2dNewRealPos.Get_X() - 10)
		End If
		If KeyDown(KEY_RIGHT) Then
			v2dNewRealPos.Set_X(v2dNewRealPos.Get_X() + fSpeed)
			v2dRealForMap.Set_X(v2dNewRealPos.Get_X() + 10)
		End If
		If KeyDown(KEY_UP) Then
			v2dNewRealPos.Set_y(v2dNewRealPos.Get_y() - fSpeed)
			v2dRealForMap.Set_y(v2dNewRealPos.Get_y() - 10)
		End If
		If KeyDown(KEY_DOWN) Then
			v2dNewRealPos.Set_y(v2dNewRealPos.Get_y() + fSpeed)
			v2dRealForMap.Set_y(v2dNewRealPos.Get_y() + 10)
		End If
		
		v2dNewMapPos = TGameMap.CalculateMapPosition(v2dRealForMap)
		
		If TGameObjectsProvider.gmMap.IsWalkable(v2dNewMapPos) Then
			v2dPositionReal = TVector2D.Create(v2dNewRealPos.Get_X(), v2dNewRealPos.Get_Y())
			v2dPositionMap = TVector2D.Create(v2dNewMapPos.Get_X(), v2dNewMapPos.Get_Y())
		EndIf
	End Method
End Type