Type TTileSet
	Field tdiaImages:TDrawnImage[]
	Field iTilesInTotal:Int
	Field sTileSetName:String
	
	Function Create:TTileSet(psPath:String, psName:String, piTileCount:Int)
		Local TileSet:TTileSet = New TTileSet
		
		TLoadedImage.CreateAnimated(psPath, psName, TGameMap.iTILESIZE,  ..
									 TGameMap.iTILESIZE, piTileCount, 0)
		TileSet.iTilesInTotal = piTileCount
		TileSet.sTileSetName = psName
		TileSet.tdiaImages = New TDrawnImage[piTileCount]
		TileSet.FillTileArray()
		
		Return TileSet
	End Function
	
	Method FillTileArray()
		For Local index:Int = 0 Until iTilesInTotal
			tdiaImages[index] = TDrawnImage.CreateFromFrame(TLoadedImage.GetImage(sTileSetName).tiImage.pixmaps[index])
		Next
	End Method
	
	Method Draw(piValue:Int, pv2dPosition:TVector2D)
		tdiaImages[piValue].Draw(pv2dPosition)
	End Method
End Type