﻿SuperStrict
Include "Includes/VectorClass.bmx"
Include "Includes/SmallFunctions.bmx"
Include "Includes/GraphicsAdministration.bmx"
Include "Includes/Globals.bmx"
Include "Includes/INIParser.bmx"
Include "Includes/INIWriter.bmx"
Include "Includes/MapClass.bmx"
Include "Includes/GameObjectsProviderClass.bmx"
Include "Includes/PlayerClass.bmx"
Include "Includes/TileSetClass.bmx"
Include "Includes/ImageTypes.bmx"
Include "Includes/GameObjectClass.bmx"
Include "Includes/MapPackClass.bmx"

AutoMidHandle(1)
SeedRnd(MilliSecs())

Graphics(1024, 768)

TMyGraphics.Init(True)
TMapPack.INIT()
TGameObject.INITAll()
TGameObjectsProvider.gmMap = TGameMap.Create(tvector2d.Create(32, 21))
TGameObjectsProvider.tsTileSet = TTileSet.Create("Data/gfx/Map/TileSetInner.png", "TestSet", 2)

Global v2dMouseMapPos:TVector2D
Global iSelectedTile:Int = 0
Global iSelectedLayer:Int = 1
Global iSelectedObject:Int = 1

Repeat
	iEnd = KeyHit(KEY_ESCAPE)
	iMouseX = MouseX()
	iMouseY = MouseY()
	v2dMouseMapPos = TGameObjectsProvider.gmMap.CalculateMapPosition(TVector2D.Create(iMouseX,  ..
																					iMouseY))
	iMouseHitLeft = MouseHit(1)
	iMouseHitRight = MouseHit(2)
	If KeyHit(KEY_UP) Then iSelectedLayer = (iSelectedLayer + 1) Mod TGameMap.iLAYERCOUNT
	If iMouseHitRight Then
		If iSelectedLayer = TGameMap.iTILELAYER Then
			iSelectedTile = (iSelectedTile + 1) Mod TGameObjectsProvider.tsTileSet.iTilesInTotal
		ElseIf iSelectedLayer = TGameMap.iOBJECTLAYER
			iSelectedObject = iSelectedObject + 1
			if iSelectedObject > TGameObject.iObjectCount Then iSelectedObject = 1
		EndIf
	EndIf
	If iMouseHitLeft Or (MouseDown(1) And KeyDown(KEY_LCONTROL)) Then
		TGameObjectsProvider.gmMap.ChangeTileValue(iSelectedLayer, v2dMouseMapPos, iSelectedTile, iSelectedObject)
	End If
	If KeyHit(KEY_F1) Then SaveMap()
	If KeyHit(KEY_F2) Then LoadMap()
	If KeyHit(KEY_F3) Then TGameObjectsProvider.gmMap.bIsDark = Not TGameObjectsProvider.gmMap.bIsDark
	If (iend Or AppTerminate()) Then SaveBeforeClosing()
	TMyGraphics.Update()
	Cls
		
	TGameObjectsProvider.gmMap.DrawMap(iSelectedLayer = TGameMap.iCOLLISIONLAYER)
	
	TGameObject.DrawAll()
	
	DrawInfos()
	
	DrawMapMouse()
	
	
	Flip 0
Until (iEnd Or AppTerminate())

Function DrawMapMouse()
	If iSelectedLayer = TGameMap.iTILELAYER
		SetAlpha(0.6)
		TGameObjectsProvider.tsTileSet.Draw(iSelectedTile, TVector2D.Create(iMouseX, iMouseY))
		SetAlpha(1)
	ElseIf iSelectedLayer = TGameMap.iOBJECTLAYER
		SetAlpha(0.6)
		TGameObject.DrawInEditor(TVector2D.Create(iMousex, imousey), iSelectedObject)
		SetAlpha(1)
	EndIf
End Function

Function SaveMap()
	Local sPath:String = RequestFile("Karte speichern.", "mmp", True, "Data/bin/Maps/")
	If (spath <> "") Then
		TGameObjectsProvider.gmMap.SaveMap(sPath)
	Else
		Notify("Dateiname war ungültig oder leer. Vorgang wird abgebrochen!")
	EndIf
End Function

Function LoadMap()
	Local sPath:String = RequestFile("Karte laden.", "mmp",, "Data/bin/Maps/")
	If (sPath <> "") Then
		TGameObject.tlallGameObjects.Clear()
		TGameObjectsProvider.gmMap = TGameMap.LoadMap(sPath)
	Else
		Notify("Dateiname war ungültig oder leer. Vorgang wird abgebrochen!")
	EndIf
End Function

Function SaveBeforeClosing()
	Notify("Sie haben nicht gespeichert. Sie haben jetzt noch die Möglichkeit dazu.")
	SaveMap()
End Function

Function DrawInfos()
	DrawText("FPS: " + Int(1000.0 / TMyGraphics.iMSC), 20, 20)
	DrawText("Tile: " + iSelectedTile, 20, 40)
 	DrawText("Layer: " + iSelectedLayer, 20, 60)
 	DrawText("Object: " + iSelectedObject, 20, 80)
End Function


